#include "stdafx.h"
#include "Capture.h"

Capture::Capture()
{
	imgCap = NULL;
//	m_capture = NULL;
}

Capture::~Capture()
{
//	Release();
}

void Capture::Release()
{
	/*
	if (m_capture!=NULL) {
		cvReleaseCapture(&m_capture);
		m_capture = NULL;
	}
	*/
	if ( imgCap!=NULL ) {
		cvReleaseImage(&imgCap);
		imgCap = NULL;
	}
	flycaptureStop(context);
	flycaptureDestroyContext(context);
}

int Capture::Init(int camera_id)
{
	/*
	m_capture = cvCreateCameraCapture(camera_id);
	if (m_capture==NULL) return -1;
	return 0;
	*/


	// J̑I
	//
	unsigned long serialNumber = camera_id;
	INT_PTR dialogStatus;
	error = flycaptureCreateContext( &context);
	guierror = pgrcamguiCreateContext( &guicontext);
	guierror = pgrcamguiShowCameraSelectionModal( guicontext, context, &serialNumber, &dialogStatus);

	if ( guierror != PGRCAMGUI_OK){
		return -1;
	}
	if ( serialNumber == 0)
		return -1;

	// J̏
	error = flycaptureInitializeFromSerialNumber( context, serialNumber);
	if ( error != FLYCAPTURE_OK)
		return -1;

	error = flycaptureStart( context, FLYCAPTURE_VIDEOMODE_ANY, FLYCAPTURE_FRAMERATE_ANY);
	if ( error != FLYCAPTURE_OK)
		return -1;

	// 摜̃TCY𓾂邽߂ɈxLv`[
	
	error = flycaptureGrabImage2( context, &rawImage);
	if ( error != FLYCAPTURE_OK)
		return -1;
	colorImage = rawImage;

	// OpenCV̉摜쐬(8bit, 3`l, BGRtH[}bg)
	imgCap = cvCreateImage( cvSize(colorImage.iCols,colorImage.iRows), IPL_DEPTH_8U, 3);

	// xC[摜 -> J[摜ϊp̃p[^Zbg
	colorImage.pixelFormat = FLYCAPTURE_BGR;
	colorImage.pData = (unsigned char*)imgCap->imageData; // ϊ̃obt@OpenCV̉摜̃obt@Ɏw

}

void Capture::SetConfig(int width, int height, int fps )
{
	/*
	cvSetCaptureProperty( m_capture, CV_CAP_PROP_FRAME_WIDTH, width );
	cvSetCaptureProperty( m_capture, CV_CAP_PROP_FRAME_HEIGHT, height );
	cvSetCaptureProperty( m_capture, CV_CAP_PROP_FPS, fps );
	*/
}

IplImage* Capture::QueryFrame(void)
{
//	return cvQueryFrame(m_capture);

	// J摜Lv`RGBJ[摜ɕϊ
	error = flycaptureGrabImage2( context, &rawImage);
	error = flycaptureConvertImage( context, &rawImage, &colorImage);

	// OpenCV̉摜ɃJ[摜Rs[
	memcpy( imgCap->imageData, colorImage.pData, colorImage.iRows * colorImage.iRowInc);

	return imgCap;
}
