#ifndef __CAPTURE_H__
#define __CAPTURE_H__


#include <cv.h>
#include <highgui.h>
#pragma comment(lib,"cv200.lib")
#pragma comment(lib,"cxcore200.lib")
#pragma comment(lib,"highgui200.lib")

#include <pgrflycapture.h>
#include <pgrcameragui.h>
#pragma comment(lib,"pgrflycapture.lib")
#pragma comment(lib,"pgrflycapturegui.lib")

class Capture {

private:
	//	CvCapture *m_capture;
	FlyCaptureImage rawImage;
	FlyCaptureImage colorImage;

	FlyCaptureContext context;
	FlyCaptureError error;
	CameraGUIContext guicontext;
	CameraGUIError guierror;
	IplImage *imgCap;

public:
	Capture();
	~Capture();

	int Init(int camera_id);
	void SetConfig(int width, int height, int fps );
	IplImage* QueryFrame();
	void Release(void);
};

#endif